Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 2528)
@@ -4,4 +4,7 @@
    !! Ice restart :  write the ice restart file
    !!======================================================================
+   !! History:   -   ! 2005-04 (M. Vancoppenolle) Original code
+   !!           3.0  ! 2008-03 (C. Ethe) restart files in using IOM interface
+   !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
@@ -12,20 +15,18 @@
    !!   lim_rst_read    : read  the restart file 
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE ice
-   USE par_ice
-   USE in_out_manager
-   USE dom_oce
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice fields
-   USE iom
+   USE ice              ! sea-ice variables
+   USE par_ice          ! sea-ice parameters
+   USE dom_oce          ! ocean domain
+   USE sbc_oce          ! Surface boundary condition: ocean fields
+   USE sbc_ice          ! Surface boundary condition: ice fields
+   USE in_out_manager   ! I/O manager
+   USE iom              ! I/O library
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC lim_rst_opn    ! routine called by icestep.F90
-   PUBLIC lim_rst_write  ! routine called by icestep.F90
-   PUBLIC lim_rst_read   ! routine called by iceinit.F90
+   PUBLIC   lim_rst_opn    ! routine called by icestep.F90
+   PUBLIC   lim_rst_write  ! routine called by icestep.F90
+   PUBLIC   lim_rst_read   ! routine called by iceini.F90
 
    LOGICAL, PUBLIC ::   lrst_ice         !: logical to control the ice restart write 
@@ -33,9 +34,8 @@
 
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008)
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -48,5 +48,5 @@
       INTEGER, INTENT(in) ::   kt       ! number of iteration
       !
-      CHARACTER(LEN=20)   ::   clkt     ! ocean time-step deine as a character
+      CHARACTER(LEN=20)   ::   clkt     ! ocean time-step define as a character
       CHARACTER(LEN=50)   ::   clname   ! ice output restart file name
       !!----------------------------------------------------------------------
@@ -54,8 +54,9 @@
       IF( kt == nit000 )   lrst_ice = .FALSE.   ! default definition
 
-      ! to get better performances with NetCDF format:
-      ! we open and define the ice restart file one ice time step before writing the data (-> at nitrst - 2*nn_fsbc + 1)
-      ! except if we write ice restart files every ice time step or if an ice restart file was writen at nitend - 2*nn_fsbc + 1
-      IF( kt == nitrst - 2*nn_fsbc + 1 .OR. nstock == nn_fsbc .OR. ( kt == nitend - nn_fsbc + 1 .AND. .NOT. lrst_ice ) ) THEN
+      ! in order to get better performances with NetCDF format, we open and define the ice restart file 
+      ! one ice time step before writing the data (-> at nitrst - 2*nn_fsbc + 1), except if we write ice 
+      ! restart files every ice time step or if an ice restart file was writen at nitend - 2*nn_fsbc + 1
+      IF( kt == nitrst - 2*nn_fsbc + 1 .OR. nstock == nn_fsbc    &
+         &                             .OR. ( kt == nitend - nn_fsbc + 1 .AND. .NOT. lrst_ice ) ) THEN
          ! beware of the format used to write kt (default is i8.8, that should be large enough...)
          IF( nitrst > 99999999 ) THEN   ;   WRITE(clkt, *       ) nitrst
@@ -75,5 +76,5 @@
             ENDIF
          ENDIF
-
+         !
          CALL iom_open( clname, numriw, ldwrt = .TRUE., kiolib = jprstlib )
          lrst_ice = .TRUE.
@@ -82,4 +83,5 @@
    END SUBROUTINE lim_rst_opn
 
+
    SUBROUTINE lim_rst_write( kt )
       !!----------------------------------------------------------------------
@@ -87,15 +89,12 @@
       !!
       !! ** purpose  :   output of sea-ice variable in a netcdf file
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt     ! number of iteration
       !!
-      !!----------------------------------------------------------------------
-      ! Arguments :
-      INTEGER, INTENT(in) ::   kt     ! number of iteration
-
-      ! Local variables :
+      INTEGER ::   ji, jj, jk ,jl   ! dummy loop indices
+      INTEGER ::   iter
+      CHARACTER(len=15) ::   znam
+      CHARACTER(len=1)  ::   zchar, zchar1
       REAL(wp), DIMENSION(jpi,jpj) :: z2d
-      INTEGER :: ji, jj, jk ,jl
-      INTEGER :: iter
-      CHARACTER(len=15) :: znam
-      CHARACTER(len=1)  :: zchar, zchar1
       !!----------------------------------------------------------------------
 
@@ -111,6 +110,6 @@
       ! ------------------ 
       !                                                                        ! calendar control
-      CALL iom_rstput( iter, nitrst, numriw, 'nn_fsbc', REAL( nn_fsbc, wp) )      ! time-step 
-      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice' , REAL( iter , wp) )        ! date
+      CALL iom_rstput( iter, nitrst, numriw, 'nn_fsbc', REAL( nn_fsbc, wp ) )      ! time-step 
+      CALL iom_rstput( iter, nitrst, numriw, 'kt_ice' , REAL( iter   , wp ) )      ! date
 
       ! Prognostic variables 
@@ -288,6 +287,6 @@
       ENDIF
       !
-
    END SUBROUTINE lim_rst_write
+
 
    SUBROUTINE lim_rst_read
@@ -297,15 +296,13 @@
       !! ** purpose  :   read of sea-ice variable restart in a netcdf file
       !!----------------------------------------------------------------------
-      ! Local variables
       INTEGER :: ji, jj, jk, jl, indx
       REAL(wp) ::   zfice, ziter
-      REAL(wp) :: & !parameters for the salinity profile
-         zs_inf, z_slope_s, zsmax, zsmin, zalpha, zindb
-      REAL(wp), DIMENSION(nlay_i) :: zs_zero 
-      REAL(wp), DIMENSION(jpi,jpj) :: z2d
-      CHARACTER(len=15) :: znam
-      CHARACTER(len=1)  :: zchar, zchar1
-      INTEGER           :: jlibalt = jprstlib
-      LOGICAL           :: llok
+      REAL(wp) ::   zs_inf, z_slope_s, zsmax, zsmin, zalpha, zindb   ! local scalars used for the salinity profile
+      REAL(wp), DIMENSION(nlay_i)  ::   zs_zero 
+      REAL(wp), DIMENSION(jpi,jpj) ::   z2d
+      CHARACTER(len=15) ::   znam
+      CHARACTER(len=1)  ::   zchar, zchar1
+      INTEGER           ::   jlibalt = jprstlib
+      LOGICAL           ::   llok
       !!----------------------------------------------------------------------
 
@@ -384,8 +381,5 @@
       END DO
 
-      ! Salinity profile
-      !-----------------
-      IF( num_sal == 2 ) THEN
-         !     CALL lim_var_salprof
+      IF( num_sal == 2 ) THEN      ! Salinity profile
          DO jl = 1, jpl
             DO jk = 1, nlay_i
@@ -393,18 +387,17 @@
                   DO ji = 1, jpi
                      zs_inf        = sm_i(ji,jj,jl)
-                     z_slope_s     = 2.0*sm_i(ji,jj,jl)/MAX(0.01,ht_i(ji,jj,jl))
+                     z_slope_s     = 2._wp * sm_i(ji,jj,jl) / MAX( 0.01_wp , ht_i(ji,jj,jl) )
                      !- slope of the salinity profile
-                     zs_zero(jk)   = z_slope_s * ( FLOAT(jk)-1.0/2.0 ) * &
-                        ht_i(ji,jj,jl) / FLOAT(nlay_i)
-                     zsmax = 4.5
-                     zsmin = 3.5
+                     zs_zero(jk)   = z_slope_s * ( REAL(jk,wp) - 0.5_wp ) * ht_i(ji,jj,jl) / REAL(nlay_i,wp)
+                     zsmax = 4.5_wp
+                     zsmin = 3.5_wp
                      IF( sm_i(ji,jj,jl) .LT. zsmin ) THEN
-                        zalpha = 1.0
+                        zalpha = 1._wp
                      ELSEIF( sm_i(ji,jj,jl) .LT.zsmax ) THEN
-                        zalpha = sm_i(ji,jj,jl) / (zsmin-zsmax) + zsmax / (zsmax-zsmin)
+                        zalpha = sm_i(ji,jj,jl) / ( zsmin - zsmax ) + zsmax / ( zsmax - zsmin )
                      ELSE
-                        zalpha = 0.0
+                        zalpha = 0._wp
                      ENDIF
-                     s_i(ji,jj,jk,jl) = zalpha*zs_zero(jk) + ( 1.0 - zalpha )*zs_inf
+                     s_i(ji,jj,jk,jl) = zalpha * zs_zero(jk) + ( 1._wp - zalpha ) * zs_inf
                   END DO
                END DO
@@ -558,9 +551,8 @@
          END DO
       END DO
-
+      !
       CALL iom_close( numrir )
-
+      !
    END SUBROUTINE lim_rst_read
-
 
 #else
